#if !defined(IOSTREAM)
	#define IOSTREAM
	#include <iostream.h>
#endif

#if !defined(MATH)
	#define MATH
	#include <math.h>
#endif

#if !defined(MYMATH)
        #define MYMATH
        #include "MyMath.h"
#endif


class vector3d
{
public:

	vector3d(void);		// simply create a null vector
	vector3d(double x, double y, double z);		// create vector using std coordinates
	vector3d operator-(void);		// -v
	vector3d operator=(const vector3d&  u);		// affectation	
	vector3d operator+(const vector3d& u);		// u+v
	vector3d operator-(const vector3d& v);		// u-v
	double operator*(const vector3d& v);		// u*v, scalar product
	friend vector3d operator*(const vector3d& u, double a);
						// multiplication by a scalar
	friend vector3d operator*(double a, const vector3d& u);
						// multiplication by a scalar			
	friend vector3d operator/(const vector3d& u, double a);
						// division by a scalar
	double norm(void);
		// Returns the norm of the vector 'u'
	vector3d operator^(const vector3d& v);		// u^v, vector product	
	double& operator[](const int& index);		// return the index element
	friend ostream& operator<<(ostream& s, const vector3d &u);
							// display u as (ux,uy,uz)
	
private:
	double x,y,z;
	double dummy;
};

// return the angle between two vector
double angle(vector3d u ,vector3d v);
